import React, { useState, useEffect, useRef } from 'react'
import CustomNav from '@/components/CustomNav'
import { useRouter } from '@tarojs/taro'
import { getShopList, getShopMoney, getAccount, getVerifiedOrder, setGetVerifiedOrder } from '@/services/shopBoss'

import TabBar from '@/components/CustTabBar'
import shopImg from '@/assets/icons/shopKeeper/orderOFF.png'
import onShopImg from '@/assets/icons/shopKeeper/orderON.png'
import spareadImg from '@/assets/icons/shopKeeper/spreadOFF.png'
import onSpareadImg from '@/assets/icons/shopKeeper/spreadON.png'
import withLayout from '@/layouts'
import ShopKeeper from '../../components/ShopKeeper/shopKeeper'
import Sparead from '../../components/Sparead/spreadMoney'


import './spreadIndex.less'


export default withLayout((props) => {
  const { router, person } = props

  const { params } = useRouter()
  const { tab } = params || {}
  const [currentTab, setCurrentTab] = useState(0)
  const [shopList, setShopList] = useState([])
  const [shop, setShop] = useState()
  const shopId = shop?.shopId

  const [amountType, setAmountType] = useState('order')
  const [isVerified, setisVerified] = useState(0)
  const [shopMoney, setShopMoney] = useState([])
  const [verifiedOrder, setVerifiedOrder] = useState([])
  const listRef = useRef()

  const handleTabChange = (e) => {

    const { index } = e.detail
    setCurrentTab(index)
    //如果context有的话代表他滚动了   那么切换tab页就置顶
    if (listRef.current?.context) {
      listRef.current.context.scrollTo({ top: 0 })

    }
  }
  const handelTypeOrder = () => {
    setAmountType('order')

  }

  const handelType = () => {
    setAmountType('commission')

  }
  //商铺列表
  useEffect(() => {
    getShopList().then((res) => {
      const { shopList: list, shop: current } = res
      setShopList(list)
      setShop(current)
    })

  }, [])


  // 搜索核销手机号
  const setVer = (e) => {
    setVerifiedOrder(e.records)



  }


  const onVarified = () => {
    setisVerified(1)
  }


  const onVarifiedTwo = () => {
    setisVerified(0)
  }

  useEffect(() => {
    if (shopId) {
      getShopMoney(shopId, amountType).then((e) => {
        setShopMoney(e)

      })
    }

  }, [amountType, shopId, currentTab])

  //店铺选择
  const handleHotelChange = (current) => {
    getShopMoney(current.shopId, amountType).then((e) => {
      setShop(current)
      getVerifiedOrder({
        isVerified: isVerified,
        pageNum: 1,
        pageSize: 99,
        shopId: current.shopId,

      }).then((res) => {
        const order = res.records
        setVerifiedOrder(order)

      })
    })
  }

  useEffect(() => {
    if (tab) {
      setCurrentTab(tab - 0)
    }
  }, [tab])

  return (
    <view className='page-index'>
      <CustomNav title={shop?.shopName} />
      <view className='index-container'>
        {currentTab === 0 && <ShopKeeper isVerified={isVerified} shopId={shopId} amountType={amountType} setVer={setVer} onVarifiedTwo={onVarifiedTwo} onVarified={onVarified} verifiedOrder={verifiedOrder} shopList={shopList} shop={shop} onHotelChange={handleHotelChange} shopMoney={shopMoney} />
        }
        {currentTab === 1 && <Sparead shopList={shopList} shop={shop} verifiedOrder={verifiedOrder} onHotelChange={handleHotelChange} shopMoney={shopMoney} />}
      </view>
      <view className='index-tabbar'>
        <TabBar extClass='custom-tabbar bottomTab' current={currentTab} onChange={handleTabChange}>
          <view className={`${currentTab === 0 ? 'orderstab' : ''}`} onClick={() => { handelTypeOrder() }}>
            <image className='incomes' src={currentTab === 0 ? onShopImg : shopImg} /><text>订单收入</text>
          </view>
          <view className={`${currentTab === 1 ? 'spreadtab' : ''}`} onClick={() => { handelType() }} >
            <image className='house' src={currentTab === 1 ? onSpareadImg : spareadImg} /><text>推广收入</text>
          </view>
        </TabBar>
      </view>
    </view>

  )

})
