import Taro from '@tarojs/taro'
import store from '@/store'

export default () => {

  return new Promise((resolve, reject) => {
    Taro.getBackgroundFetchData({
      fetchType: 'pre',
      success(res) {
        const { code, data } = JSON.parse(res.fetchedData) || {}
        if (code === 1000) {
          const { messageTpls } = data
          const { setMessageTpls } = store.getModel('system').getState()
          setMessageTpls(messageTpls)
        }
      },
      complete() {
        Taro.getLocation({
          success(res) {
            const location = `${res.longitude},${res.latitude}`
            Taro.setStorageSync('location', location)
            resolve({
              location,
            })
          },
          fail(err) {
            console.error(err)
            reject(err)
          }
        })
      }
    })
  })

  // return new Promise((resolve, reject) => {
  //   Taro.getBackgroundFetchData({
  //     fetchType: 'pre',
  //     success(res) {
  //       const { code, message, data } = JSON.parse(res.fetchedData) || {}
  //       if (code === 1000) {
  //         const { token, sessionKey, qrcode, ...otherData } = data

  //         Taro.setStorage({ key: 'token', data: token })
  //         Taro.setStorage({ key: 'sessionKey', data: sessionKey })

  //         resolve(otherData)
  //       } else {
  //         console.error(message)
  //         reject(message)
  //       }
  //     },
  //     fail: (e) => {
  //       console.error(e)
  //       reject(e.errMsg || e.message)
  //     }
  //   })
  // })
}
